import { eTSRTextureFormat, TSciChart, TSRTexture } from "../../types/TSciChart";
import { TSciChart3D } from "../../types/TSciChart3D";
import { BaseCache } from "./BaseCache";
/**
 * @ignore
 */
export declare class TextureCache extends BaseCache<TSRTexture> {
    private wasmContext;
    private width;
    private height;
    private textureFormat;
    /**
     * unlike the base class this one accepts both  context
     * @param wasmContext TSciChart or TSciChart3D
     */
    constructor(wasmContext: TSciChart | TSciChart3D);
    get value(): TSRTexture;
    /**
     * Creates or fetches a new texture with the specified params
     * @param width
     * @param height
     * @param textureFormat
     */
    create(width: number, height: number, textureFormat: eTSRTextureFormat): TSRTexture;
    resetCache(): void;
}
