import { IRenderableSeries } from "../Visuals/RenderableSeries/IRenderableSeries";
import { IPaletteProvider } from "./IPaletteProvider";
/**
 * The base class for PaletteProvider that allows you to perform per-point paletting or coloring of series or data-points
 * in SciChart's {@link https://www.scichart.com/javascript-chart-features | High Performance Realtime JavaScript Charts}
 * @remarks
 * See derived type {@link IStrokePaletteProvider} for coloring line series or strokes.
 * See derived type {@link IFillPaletteProvider} for coloring fills or areas.
 */
export declare abstract class BasePaletteProvider implements IPaletteProvider {
    onAttached(parentSeries: IRenderableSeries): void;
    onDetached(): void;
}
