import { SCRTPen, TSciChart } from "../../../types/TSciChart";
/**
 * Helper function to create a {@link SCRTPen} native pen
 * access to our WebGL2 Engine and WebAssembly numerical methods
 * @param wasmContext The {@link TSciChart | SciChart WebAssembly Context} containing
 * native methods and access to our WebGL2 WebAssembly Drawing Engine
 * @param htmlColorCode Html color code in the format "#fff", "#ff0000", "rgba(255,255,0,1)", "#11333333"
 * @param strokeThickness the stroke thickness of the pen in pixels
 * @param opacity The opacity factor
 * @param strokeDashArray the StrokeDashArray which defines any dash e.g. [2,2] means dash for 2pts, gap for 2pts (or undefined = solid line).
 */
export declare const createSCRTPen: (wasmContext: TSciChart, htmlColorCode: string, strokeThickness: number, opacity: number, strokeDashArray?: number[], antiAliased?: boolean) => SCRTPen;
