import { Vector3 } from "../../Vector3";
import { IAxisDescriptor } from "../Axis/IAxisDescriptor";
/**
 * Defines the interface a descriptor for drawing the Axis in a 3D Chart - contains properties, data and
 * parameters to pass to the WebAssembly engine for drawing an {@link AxisCubeEntity} and X,Y,Z {@link AxisBase3D}
 */
export declare class AxisCubeDescriptor {
    /**
     * Gets or sets the World-dimensions: a {@link Vector3} which defines the X,Y,Z extents of the axis cube in world-coordinates
     */
    dimensions: Vector3;
    /**
     * Gets or sets the {@link IAxisDescriptor} for the XAxis
     */
    xAxisDescriptor: IAxisDescriptor;
    /**
     * Gets or sets the {@link IAxisDescriptor} for the YAxis
     */
    yAxisDescriptor: IAxisDescriptor;
    /**
     * Gets or sets the {@link IAxisDescriptor} for the ZAxis
     */
    zAxisDescriptor: IAxisDescriptor;
    /**
     * Gets or sets whether the axis cube is visible or not
     */
    isVisible: boolean;
}
