import { CoordinateCalculatorBase } from "../../../Charting/Numerics/CoordinateCalculators/CoordinateCalculatorBase";
import { Vector3 } from "../../Vector3";
import { SceneDescriptor } from "./SceneDescriptor";
/**
 * Contains properties and data valid for the current render pass in 3D {@link SciChart3DSurface}
 */
export declare class RenderPassInfo3D {
    /**
     * The XAxis {@link CoordinateCalculatorBase | Coordinate Calculator},
     * used to transform between data-values and 3D world-coordinates
     */
    xCalc: CoordinateCalculatorBase;
    /**
     * The YAxis {@link CoordinateCalculatorBase | Coordinate Calculator},
     * used to transform between data-values and 3D world-coordinates
     */
    yCalc: CoordinateCalculatorBase;
    /**
     * The ZAxis {@link CoordinateCalculatorBase | Coordinate Calculator},
     * used to transform between data-values and 3D world-coordinates
     */
    zCalc: CoordinateCalculatorBase;
    /**
     * A {@link SceneDescriptor} object which contains data and parameters for the 3D Scene
     */
    sceneDescriptor: SceneDescriptor;
    /**
     * A {@link Vector3} which defines the X,Y,Z extents of the axis cube in world-coordinates
     */
    worldDimensions: Vector3;
}
