import { Point } from "../../../Core/Point";
import { IRenderableSeries3D } from "./BaseRenderableSeries3D";
/**
 * A non-enriched Hit-Test result (intermediate step) when calling {@link BaseRenderableSeries3D.hitTest}.
 * See {@link SeriesInfo3D} for the enriched result.
 */
export declare class HitTestInfo3D {
    /**
     * The default empty {@link HitTestInfo3D} instance
     */
    static empty(): HitTestInfo3D;
    /**
     * Gets the associated series that this {@link HitTestInfo3D} was generated by
     */
    readonly associatedSeries: IRenderableSeries3D;
    /**
     * When true, the {@link HitTestInfo3D} is empty
     */
    readonly isEmpty: boolean;
    /**
     * A screen-coordinate point where hit test is performed premultiplied by {@link DpiHelper.PIXEL_RATIO}
     */
    hitTestPoint: Point;
    /**
     * When true, the {@link hitTestPoint} (mouse point) was over an object in the 3D scene
     */
    isHit: boolean;
    /**
     * The selection index provided by SciChart's 3D Engine.
     */
    selectionIndex: number;
    /**
     * i,j selection index provided by SciChart's 3D Engine.
     */
    selectionIjIndices: Point;
    constructor(renderableSeries: IRenderableSeries3D, isEmpty?: boolean);
}
