/**
 * Enumeration constants to define the type of series, or chart type that a {@link BaseRenderableSeries} represents
 */
export declare enum ESeriesType {
    /** Type of {@link FastBandRenderableSeries}  */
    BandSeries = "BandSeries",
    /** Type of {@link SplineBandRenderableSeries}  */
    SplineBandSeries = "SplineBandSeries",
    /** Type of {@link FastBubbleRenderableSeries }  */
    BubbleSeries = "BubbleSeries",
    /** Type of {@link FastCandlestickRenderableSeries }  */
    CandlestickSeries = "CandlestickSeries",
    /** Type of {@link FastColumnRenderableSeries}  */
    ColumnSeries = "ColumnSeries",
    /** Type of {@link FastImpulseRenderableSeries}  */
    ImpulseSeries = "ImpulseSeries",
    /** Type of {@link FastLineRenderableSeries}  */
    LineSeries = "LineSeries",
    /** Type of {@link SplineLineRenderableSeries}  */
    SplineLineSeries = "SplineLineSeries",
    /** Type of {@link FastMountainRenderableSeries}  */
    MountainSeries = "MountainSeries",
    /** Type of {@link SplineMountainRenderableSeries}  */
    SplineMountainSeries = "SplineMountainSeries",
    /** Type of {@link FastOhlcRenderableSeries}  */
    OhlcSeries = "OhlcSeries",
    /** Type of {@link StackedColumnRenderableSeries}  */
    StackedColumnSeries = "StackedColumnSeries",
    /** Type of {@link StackedMountainRenderableSeries}  */
    StackedMountainSeries = "StackedMountainSeries",
    /** Type of {@link SmoothStackedMountainRenderableSeries}  */
    SmoothStackedMountainSeries = "SmoothStackedMountainSeries",
    /** Type of {@link UniformContoursRenderableSeries}  */
    UniformContoursSeries = "UniformContoursSeries",
    /** Type of {@link UniformHeatmapRenderableSeries}  */
    UniformHeatmapSeries = "UniformHeatmapSeries",
    /** Type of {@link NonUniformHeatmapRenderableSeries}  */
    NonUniformHeatmapSeries = "NonUniformHeatmapSeries",
    /** Type of {@link StackedMountainCollection}  */
    StackedMountainCollection = "StackedMountainCollection",
    /** Type of {@link StackedColumnCollection}  */
    StackedColumnCollection = "StackedColumnCollection",
    /** Type of {@link XyScatterRenderableSeries}  */
    ScatterSeries = "ScatterSeries",
    /** Type of {@link FastErrorBarsRenderableSeries}  */
    ErrorBarsSeries = "ErrorBarsSeries",
    /** Type of {@link FastTextRenderableSeries}  */
    TextSeries = "TextSeries",
    /** Custom series type */
    Custom = "Custom"
}
